package com.ejie.ab79.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.DatosEstablecimiento;
import com.ejie.ab79.model.inspecciones.Inspecciones;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * DatosEstablecimientoDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class DatosEstablecimientoDaoImpl implements DatosEstablecimientoDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDDATOESTABLECIMIENTO", "IDCATEGORIAS",
			"IDTIPOESTABLECIMIENTO", "IDMODALIDAD", "IDINSPECCION", "FECHAREGISTRO", "USUARIOREGISTRO" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<DatosEstablecimiento> rwMap = new RowMapper<DatosEstablecimiento>() {
		public DatosEstablecimiento mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new DatosEstablecimiento(resultSet.getInt("ID_DATO_ESTABLECIMIENTO"),
					resultSet.getString("ID_CATEGORIAS"), resultSet.getString("ID_TIPO_ESTABLECIMIENTO"),
					resultSet.getString("ID_MODALIDAD"), resultSet.getInt("ID_INSPECCION"),
					resultSet.getDate("FECHA_REGISTRO"), resultSet.getString("USUARIO_REGISTRO"));
		}
	};

	private RowMapper<DatosEstablecimiento> rwMapPK = new RowMapper<DatosEstablecimiento>() {
		public DatosEstablecimiento mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new DatosEstablecimiento(resultSet.getInt("ID_DATO_ESTABLECIMIENTO"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<DatosEstablecimiento>> rwMapJerarquia = new RowMapper<JerarquiaDto<DatosEstablecimiento>>() {
		public JerarquiaDto<DatosEstablecimiento> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			DatosEstablecimiento datosestablecimiento = new DatosEstablecimiento(
					resultSet.getInt("ID_DATO_ESTABLECIMIENTO"), resultSet.getString("ID_CATEGORIAS"),
					resultSet.getString("ID_TIPO_ESTABLECIMIENTO"), resultSet.getString("ID_MODALIDAD"),
					resultSet.getInt("ID_INSPECCION"), resultSet.getDate("FECHA_REGISTRO"),
					resultSet.getString("USUARIO_REGISTRO"));

			JerarquiaDto<DatosEstablecimiento> jerarquia = new JerarquiaDto<DatosEstablecimiento>();
			jerarquia.setModel(datosestablecimiento);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	private RowMapper<DatosEstablecimiento> rwMapInspeccion = new RowMapper<DatosEstablecimiento>() {
		public DatosEstablecimiento mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			DatosEstablecimiento datosEstablecimiento = new DatosEstablecimiento();
			datosEstablecimiento.setIdentEstablecimiento(resultSet.getString("IDENTESTABLECIMIENTO"));
			datosEstablecimiento.setIdDatoEstablecimiento(resultSet.getInt("IDDATOESTABLECIMIENTO"));
			datosEstablecimiento.setIdCategorias(resultSet.getString("IDCATEGORIAS"));
			datosEstablecimiento.setIdTipoEstablecimiento(resultSet.getString("IDTIPOESTABLECIMIENTO"));
			datosEstablecimiento.setIdModalidad(resultSet.getString("IDMODALIDAD"));
			datosEstablecimiento.setIdInspeccion(resultSet.getInt("IDINSPECCION"));
			datosEstablecimiento.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			datosEstablecimiento.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			return datosEstablecimiento;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the DatosEstablecimiento table.
	 *
	 * @param datosestablecimiento
	 *            DatosEstablecimiento
	 * @return DatosEstablecimiento
	 */
	public DatosEstablecimiento add(DatosEstablecimiento datosestablecimiento) {
		int idDatoEstablecimiento = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7920T00.NEXTVAL FROM DUAL",
				Integer.class);
		datosestablecimiento.setIdDatoEstablecimiento(idDatoEstablecimiento);
		String query = "INSERT INTO DATOS_ESTABLECIMIENTO (ID_DATO_ESTABLECIMIENTO, ID_CATEGORIAS, ID_TIPO_ESTABLECIMIENTO, ID_MODALIDAD, ID_INSPECCION, IDENT_ESTABLECIMIENTO, FECHA_REGISTRO, USUARIO_REGISTRO) VALUES (?,?,?,?,?,?,?,?)";
		this.jdbcTemplate.update(query, datosestablecimiento.getIdDatoEstablecimiento(),
				datosestablecimiento.getIdCategorias(), datosestablecimiento.getIdTipoEstablecimiento(),
				datosestablecimiento.getIdModalidad(), datosestablecimiento.getIdInspeccion(),
				datosestablecimiento.getIdentEstablecimiento(), datosestablecimiento.getFechaRegistro(),
				datosestablecimiento.getUsuarioRegistro());
		return datosestablecimiento;
	}

	/**
	 * Updates a single row in the DatosEstablecimiento table.
	 *
	 * @param datosestablecimiento
	 *            DatosEstablecimiento
	 * @return DatosEstablecimiento
	 */
	public DatosEstablecimiento update(DatosEstablecimiento datosestablecimiento) {
		String query = "UPDATE DATOS_ESTABLECIMIENTO SET ID_CATEGORIAS=?, ID_TIPO_ESTABLECIMIENTO=?, ID_MODALIDAD=?, ID_INSPECCION=?, FECHA_REGISTRO=?, USUARIO_REGISTRO=? WHERE ID_DATO_ESTABLECIMIENTO=?";
		this.jdbcTemplate.update(query, datosestablecimiento.getIdCategorias(),
				datosestablecimiento.getIdTipoEstablecimiento(), datosestablecimiento.getIdModalidad(),
				datosestablecimiento.getIdInspeccion(), datosestablecimiento.getFechaRegistro(),
				datosestablecimiento.getUsuarioRegistro(), datosestablecimiento.getIdDatoEstablecimiento());
		return datosestablecimiento;
	}

	/**
	 * Finds a single row in the DatosEstablecimiento table.
	 *
	 * @param datosestablecimiento
	 *            DatosEstablecimiento
	 * @return DatosEstablecimiento
	 */
	@Transactional(readOnly = true)
	public DatosEstablecimiento find(DatosEstablecimiento datosestablecimiento) {
		String query = "SELECT t1.ID_DATO_ESTABLECIMIENTO IDDATOESTABLECIMIENTO, t1.ID_CATEGORIAS IDCATEGORIAS, t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO, t1.ID_MODALIDAD IDMODALIDAD, t1.ID_INSPECCION IDINSPECCION, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO FROM DATOS_ESTABLECIMIENTO t1  WHERE t1.ID_DATO_ESTABLECIMIENTO = ?  ";

		List<DatosEstablecimiento> datosestablecimientoList = this.jdbcTemplate.query(query, this.rwMap,
				datosestablecimiento.getIdDatoEstablecimiento());
		return (DatosEstablecimiento) DataAccessUtils.uniqueResult(datosestablecimientoList);
	}

	/**
	 * Removes a single row in the DatosEstablecimiento table.
	 *
	 * @param datosestablecimiento
	 *            DatosEstablecimiento
	 * @return
	 */
	public void remove(DatosEstablecimiento datosestablecimiento) {
		String query = "DELETE FROM DATOS_ESTABLECIMIENTO WHERE ID_DATO_ESTABLECIMIENTO=?";
		this.jdbcTemplate.update(query, datosestablecimiento.getIdDatoEstablecimiento());
	}

	@Override
	public void removeByInspecciones(Inspecciones inspeccion) {
		String query = "DELETE FROM DATOS_ESTABLECIMIENTO WHERE ID_INSPECCION = ?";
		this.jdbcTemplate.update(query, inspeccion.getIdInspeccion());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<DatosEstablecimiento> getMultiple(DatosEstablecimiento filterDatosEstablecimiento,
			TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterDatosEstablecimiento, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, DatosEstablecimiento.class,
				params, "ID_DATO_ESTABLECIMIENTO");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the DatosEstablecimiento table.
	 *
	 * @param datosestablecimiento
	 *            DatosEstablecimiento
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<DatosEstablecimiento>
	 */
	@Transactional(readOnly = true)
	public List<DatosEstablecimiento> findAll(DatosEstablecimiento datosestablecimiento,
			TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_DATO_ESTABLECIMIENTO IDDATOESTABLECIMIENTO,t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.ID_MODALIDAD IDMODALIDAD,t1.ID_INSPECCION IDINSPECCION,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM DATOS_ESTABLECIMIENTO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(datosestablecimiento);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					DatosEstablecimientoDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<DatosEstablecimiento>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the DatosEstablecimiento table using like.
	 *
	 * @param datosestablecimiento
	 *            DatosEstablecimiento
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<DatosEstablecimiento>
	 */
	@Transactional(readOnly = true)
	public List<DatosEstablecimiento> findAllLike(DatosEstablecimiento datosestablecimiento,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_DATO_ESTABLECIMIENTO IDDATOESTABLECIMIENTO,t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.ID_MODALIDAD IDMODALIDAD,t1.ID_INSPECCION IDINSPECCION,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		query.append("FROM DATOS_ESTABLECIMIENTO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(datosestablecimiento, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					DatosEstablecimientoDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<DatosEstablecimiento>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public DatosEstablecimiento findByInspeccion(Inspecciones inspeccion) {
		String query = "SELECT t1.IDENT_ESTABLECIMIENTO IDENTESTABLECIMIENTO,"
				+ "t1.ID_DATO_ESTABLECIMIENTO IDDATOESTABLECIMIENTO," + "t1.ID_CATEGORIAS IDCATEGORIAS,"
				+ "t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO," + "ID_MODALIDAD IDMODALIDAD,"
				+ "ID_INSPECCION IDINSPECCION," + "FECHA_REGISTRO FECHAREGISTRO," + "USUARIO_REGISTRO USUARIOREGISTRO"
				+ " FROM DATOS_ESTABLECIMIENTO t1 WHERE ID_INSPECCION = ?";

		List<DatosEstablecimiento> datosestablecimientoList = this.jdbcTemplate.query(query, this.rwMapInspeccion,
				inspeccion.getIdInspeccion());
		if (datosestablecimientoList.size() > 0) {
			return (DatosEstablecimiento) DataAccessUtils.uniqueResult(datosestablecimientoList);
		}
		return new DatosEstablecimiento();
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the DatosEstablecimiento table.
	 *
	 * @param datosestablecimiento
	 *            DatosEstablecimiento
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(DatosEstablecimiento datosestablecimiento) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM DATOS_ESTABLECIMIENTO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(datosestablecimiento);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the DatosEstablecimiento table using like.
	 *
	 * @param datosestablecimiento
	 *            DatosEstablecimiento
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(DatosEstablecimiento datosestablecimiento, Boolean startsWith) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM DATOS_ESTABLECIMIENTO t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(datosestablecimiento, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of DatosEstablecimiento selected for rup_table
	 *
	 * @param datosestablecimiento
	 *            DatosEstablecimiento
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DatosEstablecimiento>>
	 */
	@Override
	public List<TableRowDto<DatosEstablecimiento>> reorderSelection(DatosEstablecimiento datosestablecimiento,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DATO_ESTABLECIMIENTO IDDATOESTABLECIMIENTO,t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.ID_MODALIDAD IDMODALIDAD,t1.ID_INSPECCION IDINSPECCION,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM DATOS_ESTABLECIMIENTO t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(datosestablecimiento, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				DatosEstablecimiento.class, filterParamList, "ID_DATO_ESTABLECIMIENTO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<DatosEstablecimiento>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            DatosEstablecimiento
	 * @param searchParams
	 *            DatosEstablecimiento
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<DatosEstablecimiento>>
	 */
	@Override
	public List<TableRowDto<DatosEstablecimiento>> search(DatosEstablecimiento filterParams,
			DatosEstablecimiento searchParams, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DATO_ESTABLECIMIENTO IDDATOESTABLECIMIENTO,t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.ID_MODALIDAD IDMODALIDAD,t1.ID_INSPECCION IDINSPECCION,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM DATOS_ESTABLECIMIENTO t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto,
				DatosEstablecimiento.class, filterParamList, searchSQL, searchParamList, from_alias,
				"ID_DATO_ESTABLECIMIENTO");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<DatosEstablecimiento>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterdatosestablecimiento
	 *            DatosEstablecimiento
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(DatosEstablecimiento filterdatosestablecimiento, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DATO_ESTABLECIMIENTO IDDATOESTABLECIMIENTO,t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.ID_MODALIDAD IDMODALIDAD,t1.ID_INSPECCION IDINSPECCION,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM DATOS_ESTABLECIMIENTO t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterdatosestablecimiento, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto,
				DatosEstablecimiento.class, query, params, "ID_DATO_ESTABLECIMIENTO");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical DatosEstablecimiento table.
	 *
	 * @param filterDatosEstablecimiento
	 *            DatosEstablecimiento
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<DatosEstablecimiento>>
	 */
	@Override
	public List<JerarquiaDto<DatosEstablecimiento>> findAllLikeJerarquia(
			DatosEstablecimiento filterDatosEstablecimiento, TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_DATO_ESTABLECIMIENTO IDDATOESTABLECIMIENTO,t1.ID_CATEGORIAS IDCATEGORIAS,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.ID_MODALIDAD IDMODALIDAD,t1.ID_INSPECCION IDINSPECCION,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM DATOS_ESTABLECIMIENTO t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("DATOS_ESTABLECIMIENTO");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterDatosEstablecimiento, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_DATO_ESTABLECIMIENTO", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					DatosEstablecimientoDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterDatosEstablecimiento
	 *            DatosEstablecimiento
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(DatosEstablecimiento filterDatosEstablecimiento,
			TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM DATOS_ESTABLECIMIENTO t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("DATOS_ESTABLECIMIENTO");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterDatosEstablecimiento, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_DATO_ESTABLECIMIENTO",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterDatosEstablecimiento
	 *            DatosEstablecimiento
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<DatosEstablecimiento>>
	 */
	@Override
	public List<TableRowDto<DatosEstablecimiento>> findAllChild(DatosEstablecimiento filterDatosEstablecimiento,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM DATOS_ESTABLECIMIENTO t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("DATOS_ESTABLECIMIENTO");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterDatosEstablecimiento, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
				"ID_DATO_ESTABLECIMIENTO", "ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<DatosEstablecimiento>(this.rwMapPK, "ID_DATO_ESTABLECIMIENTO"),
				params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the DatosEstablecimiento entity
	 *
	 * @param datosestablecimiento
	 *            DatosEstablecimiento Bean with the criteria values to filter
	 *            by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(DatosEstablecimiento datosestablecimiento) {

		StringBuilder where = new StringBuilder(DatosEstablecimientoDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (datosestablecimiento != null && datosestablecimiento.getIdDatoEstablecimiento() != null) {
			where.append(" AND t1.ID_DATO_ESTABLECIMIENTO = ?");
			params.add(datosestablecimiento.getIdDatoEstablecimiento());
		}
		if (datosestablecimiento != null && datosestablecimiento.getIdCategorias() != null) {
			where.append(" AND t1.ID_CATEGORIAS = ?");
			params.add(datosestablecimiento.getIdCategorias());
		}
		if (datosestablecimiento != null && datosestablecimiento.getIdTipoEstablecimiento() != null) {
			where.append(" AND t1.ID_TIPO_ESTABLECIMIENTO = ?");
			params.add(datosestablecimiento.getIdTipoEstablecimiento());
		}
		if (datosestablecimiento != null && datosestablecimiento.getIdModalidad() != null) {
			where.append(" AND t1.ID_MODALIDAD = ?");
			params.add(datosestablecimiento.getIdModalidad());
		}
		if (datosestablecimiento != null && datosestablecimiento.getIdInspeccion() != null) {
			where.append(" AND t1.ID_INSPECCION = ?");
			params.add(datosestablecimiento.getIdInspeccion());
		}
		if (datosestablecimiento != null && datosestablecimiento.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(datosestablecimiento.getFechaRegistro());
		}
		if (datosestablecimiento != null && datosestablecimiento.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(datosestablecimiento.getUsuarioRegistro());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the DatosEstablecimiento entity
	 *
	 * @param datosestablecimiento
	 *            DatosEstablecimiento Bean with the criteria values to filter
	 *            by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(DatosEstablecimiento datosestablecimiento, Boolean startsWith) {

		StringBuilder where = new StringBuilder(DatosEstablecimientoDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (datosestablecimiento != null && datosestablecimiento.getIdDatoEstablecimiento() != null) {
			where.append(" AND t1.ID_DATO_ESTABLECIMIENTO = ?");
			params.add(datosestablecimiento.getIdDatoEstablecimiento());
		}
		if (datosestablecimiento != null && datosestablecimiento.getIdCategorias() != null) {
			where.append(" AND UPPER(t1.ID_CATEGORIAS) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(datosestablecimiento.getIdCategorias().toUpperCase() + "%");
			} else {
				params.add("%" + datosestablecimiento.getIdCategorias().toUpperCase() + "%");
			}
			where.append(" AND t1.ID_CATEGORIAS IS NOT NULL");
		}
		if (datosestablecimiento != null && datosestablecimiento.getIdTipoEstablecimiento() != null) {
			where.append(" AND UPPER(t1.ID_TIPO_ESTABLECIMIENTO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(datosestablecimiento.getIdTipoEstablecimiento().toUpperCase() + "%");
			} else {
				params.add("%" + datosestablecimiento.getIdTipoEstablecimiento().toUpperCase() + "%");
			}
			where.append(" AND t1.ID_TIPO_ESTABLECIMIENTO IS NOT NULL");
		}
		if (datosestablecimiento != null && datosestablecimiento.getIdModalidad() != null) {
			where.append(" AND UPPER(t1.ID_MODALIDAD) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(datosestablecimiento.getIdModalidad().toUpperCase() + "%");
			} else {
				params.add("%" + datosestablecimiento.getIdModalidad().toUpperCase() + "%");
			}
			where.append(" AND t1.ID_MODALIDAD IS NOT NULL");
		}
		if (datosestablecimiento != null && datosestablecimiento.getIdInspeccion() != null) {
			where.append(" AND t1.ID_INSPECCION = ?");
			params.add(datosestablecimiento.getIdInspeccion());
		}
		if (datosestablecimiento != null && datosestablecimiento.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(datosestablecimiento.getFechaRegistro());
		}
		if (datosestablecimiento != null && datosestablecimiento.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(datosestablecimiento.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + datosestablecimiento.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

}
